;Reflected playfield goodness 


      processor 6502 
      include "vcs.h" 
      include "macro.h" 


COUNTER1    = $80 
COLOROFFSET   = $81 
TIMETOCHANGE  = 2          ; speed of "animation" 

      SEG 
      ORG $F000 

Reset 
; Clear RAM and all TIA registers 

        ldx #0 
        lda #0 
Clear      sta 0,x 
        inx 
        bne Clear 

    ;------------------------------------------------ 
    ; Once-only initialisation... 

        lda #0 
        ;lda #$45 
        sta COLUPF       ; set the playfield colour 
        lda #%00000001 
        sta CTRLPF       ; reflect playfield 
        lda #$00 
        sta COLUBK 

StartOfFrame 

  ; Start of vertical blank processing 

      lda #0 
      sta VBLANK 

      lda #2 
      sta VSYNC 
      
        ; 3 scanlines of VSYNCH signal... 

        sta WSYNC 
        sta WSYNC 
        sta WSYNC 

      lda #0 
      sta VSYNC      



        ; 37 scanlines of vertical blank... 
      
        ldx #0 
VerticalBlank  sta WSYNC 
        inx 
        cpx #36 ; Now waiting 36 lines 
        bne VerticalBlank 

        ;do some color offset calcs 

        ldy COUNTER1 
        cpy #TIMETOCHANGE 
        bne notyet 

        inc COLOROFFSET 
        ldy COLOROFFSET 
        lda #0 
        sta COUNTER1 

notyet 
        inc COUNTER1 
        ldy COLOROFFSET 
        
        sta WSYNC ; wait for last line of vblank 

DrawField    
        ldx #0         ; this counts our scanline number 

        lda #%11111111 
        sta PF0 
        sta PF1 
        sta PF2 

Top       sta WSYNC 
        sty COLUPF 
        
        lda #0 
        inx 
        iny 
        cpx #8 
        bne Top 
        
        lda #%00010000     ; PF0 is mirrored <--- direction, low 4 bits ignored 
        sta PF0 
        lda #0 
        sta PF1 
        sta PF2 

Middle     sta WSYNC        
        sty COLUPF 
        inx 
        iny 
        cpx #36 
        bne Middle 

        lda #%11100000 
        sta PF2 
        lda #0 
        sta PF1 

Line0      sta WSYNC 
        sty COLUPF 
        inx 
        iny 
        cpx #44 
        bne Line0 

        lda #$F0 
        sta PF2 
        lda #0 
        sta PF1 

Line1      sta WSYNC 
        sty COLUPF 
        inx 
        iny 
        cpx #52 
        bne Line1 

        lda #%11111000 
        sta PF2 
        lda #0 
        sta PF1 

Line2      sta WSYNC 
        sty COLUPF 
        inx 
        iny 
        cpx #60 
        bne Line2 


        lda #%11111100 
        sta PF2 
        lda #0 
        sta PF1 


Line3      sta WSYNC 
        sty COLUPF 
        inx 
        iny 
        cpx #68 
        bne Line3 

        lda #%11101110 
        sta PF2 
        lda #0 
        sta PF1 


Line4      sta WSYNC 
        sty COLUPF 
        inx 
        iny 
        cpx #76 
        bne Line4 

        lda #%11101111 
        sta PF2 
        lda #0 
        sta PF1 

Line5      sta WSYNC 
        sty COLUPF 
        inx 
        iny 
        cpx #84 
        bne Line5 


        lda #%11111111 
        sta PF2 
        lda #0 
        sta PF1 


Line6      sta WSYNC 
        sty COLUPF 
        inx 
        iny 
        cpx #92 
        bne Line6 

        lda #%11111011 
        sta PF2 
        lda #0 
        sta PF1 



Line7      sta WSYNC 
        sty COLUPF 
        inx 
        ;dey 
        cpx #100 
        bne Line7 


        lda #%11111011 
        sta PF2 
        lda #0 
        sta PF1 


Line8      sta WSYNC 
        sty COLUPF 
        inx 
        dey 
        cpx #108 
        bne Line8 
        
        lda #%11110111 
        sta PF2 
        lda #0 
        sta PF1 


Line9      sta WSYNC 
        sty COLUPF 
        inx 
        dey 
        cpx #116 
        bne Line9 

        lda #%11101110 
        sta PF2 
        lda #0 
        sta PF1 


Line10     sta WSYNC 
        sty COLUPF 
        inx 
        dey 
        cpx #124 
        bne Line10 

        lda #%11011100 
        sta PF2 
        lda #0 
        sta PF1 

Line11     sta WSYNC 
        sty COLUPF 
        inx 
        dey 
        cpx #132 
        bne Line11 

        lda #%00111000 
        sta PF2 
        lda #0 
        sta PF1 

Line12     sta WSYNC 
        sty COLUPF 
        inx 
        dey 
        cpx #140 
        bne Line12 

        lda #%11110000 
        sta PF2 
        lda #0 
        sta PF1 

Line13     sta WSYNC 
        sty COLUPF 
        inx 
        dey 
        cpx #148 
        bne Line13 

        lda #%11100000 
        sta PF2 
        lda #0 
        sta PF1 


Line14     sta WSYNC 
        sty COLUPF 
        inx 
        dey 
        cpx #156 
        bne Line14 


        lda #%00010000     
        sta PF0 
        lda #0 
        sta PF1 
        sta PF2 


BottomMid    sta WSYNC        
        sty COLUPF 
        inx 
        dey 
        cpx #184 
        bne BottomMid 

        lda #%11111111 
        sta PF0 
        sta PF1 
        sta PF2 

Bottom     sta WSYNC        

        sty COLUPF 
        inx 
        dey 
        cpx #192 
        bne Bottom   


      lda #%01000010 
      sta VBLANK           ; end of screen - enter blanking 

        ldx #0 
        stx COLUPF 
Overscan    sta WSYNC 
        inx 
        cpx #30 
        bne Overscan 
        
        jmp StartOfFrame 


      ORG $FFFA 

      .word Reset      ; NMI 
      .word Reset      ; RESET 
      .word Reset      ; IRQ 

    END